#pragma once

#define CU_COLOR_NORMAL_TEXT		(RGB(34, 34, 34))		// #222222
#define CU_COLOR_NORMAL_BK			(RGB(230, 233, 238))
#define CU_COLOR_OVER_BK			(RGB(218, 223, 229))	// #dadfe5
#define CU_COLOR_SELECTED_TEXT		(RGB(34, 34, 34))		// #222222
#define CU_COLOR_SELECTED_BK		(RGB(215, 219, 224))	// #d7dbe0
#define CU_COLOR_INVITE_TEXT		(RGB(44, 112, 252))

// ÷ 
#define UL_COLUMN_STATUS		0
#define UL_COLUMN_NAME			1
#define UL_COLUMN_IPT			2

class CChatUserList : public CListCtrl
{
	DECLARE_DYNAMIC(CChatUserList)

public:
	CChatUserList();
	virtual ~CChatUserList();

	// attribute
	typedef struct _chat_user_info
	{
		CString				strUserID;
		CString				strUserName;
		CString				strUserNickName;
		CString				strUserDepart;
		CString				strIncoTel;
		CString				strExtensionTel;
		CString				strCellphone;
		CString				strJobPos;
		CString				strJobDuty;
		CString				strUserInviteStatus;
		GTUserStatusType	eUserStatus;
		NTIPTStatusType		eIPTStatus;

		_chat_user_info()
		{
			strUserID = _T("");
			strUserName = _T("");
			strUserNickName = _T("");
			strUserDepart = _T("");
			strIncoTel = _T("");
			strExtensionTel = _T("");
			strCellphone = _T("");
			strJobPos = _T("");
			strJobDuty = _T("");
			strUserInviteStatus = _T("");
			eUserStatus = ustOFFLINE;
			eIPTStatus = iptstNA;
		}

		_chat_user_info& operator = (const _chat_user_info& rCopy)
		{
			if (this == &rCopy)
			{
				return *this;
			}
			strUserID = rCopy.strUserID;
			strUserName = rCopy.strUserName;
			strUserNickName = rCopy.strUserNickName;
			strUserDepart = rCopy.strUserDepart;
			strIncoTel = rCopy.strIncoTel;
			strExtensionTel =  rCopy.strExtensionTel;
			strCellphone =  rCopy.strCellphone;
			strJobPos =  rCopy.strJobPos;
			strJobDuty =  rCopy.strJobDuty;
			strUserInviteStatus =  rCopy.strUserInviteStatus;
			eUserStatus =  rCopy.eUserStatus;
			eIPTStatus =  rCopy.eIPTStatus;

			return *this;
		}
	} CHAT_USER_INFO, *PCHAT_USER_INFO;

	struct HOVER_ITEM
	{
		int     iItem;
		int     iSubItem;

		HOVER_ITEM()
		{
			iItem = -1;
			iSubItem = 0;
		}
	};

	void		SetUserStatus(int nItem, GTUserStatusType nStatus);

	void		ClearUserListItem();
	void		DeleteChatItem(CString strUserName, CString strUserNickName);
	void		SetRowHeight(int nRowHeight);
	BOOL		SetItemImage(int nItem, int nSubItem, int nImage);
	void		SetIPTPresenceImageList(CImageList* pilIPTPresence);
	void		UnSelectAll();
	void        SetEnableHoveFlag(bool flag);

	CCriticalSection*	GetLockObject() { return &m_csLock; }
protected:
	DECLARE_MESSAGE_MAP()
	
	afx_msg void MeasureItem(LPMEASUREITEMSTRUCT lpMeasureItemStruct);
	afx_msg void OnNcCalcSize(BOOL bCalcValidRects, NCCALCSIZE_PARAMS* lpncsp);

	afx_msg void OnCustomDraw(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg LRESULT OnUmSplitterMove(WPARAM wParam, LPARAM lParam);
	afx_msg void OnLvnHotTrack(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg BOOL OnSetCursor(CWnd* pWnd, UINT nHitTest, UINT message);
	afx_msg void OnTimer(UINT_PTR nIDEvent);
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnKillFocus(CWnd* pNewWnd);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnMouseHover(UINT nFlags, CPoint point);
	afx_msg void OnMouseLeave();

private:
	int			CellRectFromPoint(CPoint & point, RECT * cellrect, int * col) const;
	void		DrawSubItem(int nItem, int nSubItem, CDC *pDC);
	void		GetDrawColors(int nItem, int nSubItem, COLORREF& colorText, COLORREF& colorBkgnd);

	CImageList *m_pilIPTPresence;
	BOOL		m_bHandCursor;
	HOVER_ITEM	m_hoverItem;			//  콺 ö ִ 

	CCriticalSection	m_csLock;
	int			m_uItemHeight;
	bool           m_bMouseTrack; 
	int             m_nPrevIndex;
	bool          m_bEnableHove;

public:
	virtual void DrawItem(_In_ LPDRAWITEMSTRUCT lpDrawItemStruct);
};
